@echo off
setlocal enabledelayedexpansion enableextensions
chcp 65001
CLS
CD /d %~dp0 & TITLE Rift 16X 4060 ^& 4070 Installation Script
>NUL 2>&1 REG.exe query "HKU\S-1-5-19" || (
ECHO SET UAC = CreateObject^("Shell.Application"^) > "%TEMP%\Getadmin.vbs"
ECHO UAC.ShellExecute "%~f0", "%1", "", "runas", 1 >> "%TEMP%\Getadmin.vbs"
"%TEMP%\Getadmin.vbs"
DEL /f /q "%TEMP%\Getadmin.vbs" 2>NUL
EXIT /b
)
CLS
ECHO.
ECHO [93mAdministrative permissions required.[0m Detecting permissions...
ECHO.
NET session >NUL 2>&1
 
IF %ERRORLEVEL% == 0 (
	ECHO [92mSuccess:[0m Administrative permissions confirmed.
	ECHO.
) ELSE (
	ECHO [91mFailure:[0m Current permissions inadequate. This script requires administrator privileges.
	ECHO.
	ECHO To do this, right-click, and then select 'Run as administrator'.
	ECHO.
	ECHO Exiting in 5 Seconds...
	CHOICE /C A /N /T 5 /D A
	IF %ERRORLEVEL%==1 (
		GOTO :EOF
	)
)

SET OverallStatus=

ECHO [93mInstalling:[0m Intel Dynamic Tuning Technology v9.0.11401.39039
pnputil -i -a "%~dp0Install\dtt_sw.inf" >nul & ECHO %ERRORLEVEL% > "%~dp0Install\exitcode1.txt"
CALL :ProcessErrorCode "%~dp0Install\exitcode1.txt"
DEL "%~dp0Install\exitcode1.txt">nul

pnputil -i -a "%~dp0Install\dtt_ext.inf" >nul & ECHO %ERRORLEVEL% > "%~dp0Install\exitcode2.txt"
CALL :ProcessErrorCode "%~dp0Install\exitcode2.txt"
CALL :DisplayErrorCode
DEL "%~dp0Install\exitcode2.txt">nul

ECHO.
ECHO [93mInstalling:[0m Intel Apllication Optimization

CHCP 437>NUL
Powershell -command "Add-AppxPackage -Path '%~dp0Install\ApoInstaller.msix'" >nul
CHCP 65001>NUL

IF %ERRORLEVEL% GTR 0 (
	ECHO.
	ECHO [31mInstallation Failed[0m %ERRORLEVEL%
) ELSE (
	ECHO.
	ECHO [32mInstalled Successfully[0m
)

SET ErrorCode=

:Close
timeout 10 >nul
GOTO :EOF

:Reboot
timeout 5 >nul
Shutdown /r /t 5
GOTO :EOF

:ProcessErrorCode
SET /P ErrorCode=<%1

IF %ErrorCode% EQU 0 IF NOT DEFINED OverallStatus SET "OverallStatus=3" & GOTO :EOF
IF %ErrorCode% EQU 0 GOTO :EOF
IF %ErrorCode% EQU 3010 IF %OverallStatus% EQU 3 SET "OverallStatus=2" & GOTO :EOF
IF %ErrorCode% EQU 3010 GOTO :EOF
IF %ErrorCode% EQU 1641 IF %OverallStatus% EQU 3 SET "OverallStatus=2" & GOTO :EOF
IF %ErrorCode% EQU 1641 GOTO :EOF
IF %ErrorCode% EQU 259 IF %OverallStatus% EQU 3 SET "OverallStatus=1" & GOTO :EOF
IF %ErrorCode% EQU 259 IF %OverallStatus% EQU 2 SET "OverallStatus=1" & GOTO :EOF
IF %ErrorCode% EQU 259 GOTO :EOF
SET "OverallStatus=0"
GOTO :EOF

:DisplayErrorCode

IF %OverallStatus% EQU 3 ECHO. & ECHO [32mOperation completed successfully.[0m
IF %OverallStatus% EQU 2 ECHO. & ECHO [32mOperation successful. Your computer is restarting now.[0m & GOTO Reboot
IF %OverallStatus% EQU 1 ECHO. & ECHO [33mTthe device already has a suitable driver.[0m
IF %OverallStatus% EQU 0 ECHO. & ECHO [31mOperation unsuccessfully.[0m & GOTO Close

GOTO :EOF